
#include "gamedll_utils.h"

CPlayerHandler* g_Players;

void CPlayerHandler::PutInServer(int id)
{
	if(IsPlayer(id))
		players[id-1]->PutInServer(id);
}

void CPlayerHandler::Disconnect(int id)
{
	if(IsPlayer(id))
		players[id-1]->Disconnect();
}

void CPlayerHandler::Killed(int id)
{
	if(IsPlayer(id))
		players[id-1]->Killed();
}

void CPlayerHandler::Spawn(int id)
{
	if(IsPlayer(id))
		players[id-1]->Spawn();
}

void CPlayerHandler::JoinTeam(int id, int team)
{
	if(IsPlayer(id) && team > 0)
		players[id-1]->JoinTeam(team);
}

bool CPlayerHandler::IsAlive(int id)
{
	if(IsPlayer(id))
		return players[id-1]->IsAlive();

	return false;
}

bool CPlayerHandler::IsInGame(int id)
{
	if(IsPlayer(id))
	{
		return players[id-1]->IsInGame();
	}

	return false;
}

