
#ifndef _CBASE_ENT_
#define _CBASE_ENT_

#ifndef STEAMCMD
#define VTABLE_OFFSET	0x94	// old cs = 0x94 - new cs = 0x00
#define VTABLE_START	0x02	// old cs = 0x02 - new cs = 0x00 (::Spawn)
#else
#define VTABLE_OFFSET	0x00	// old cs = 0x94 - new cs = 0x00
#define VTABLE_START	0x00	// old cs = 0x02 - new cs = 0x00 (::Spawn)
#endif

typedef struct
{
#ifdef __linux__
	#ifdef STEAMCMD
		void** vtable;
	#endif
#else
	void** vtable;
#endif
	entvars_t* pev;
	void* m_pGoalEnt;
	void* m_pLink;
	void* m_pfnThinkFlag;
	void* m_pfnThink;
	void* m_pfnTouchFlag;
	void* m_pfnTouch;
	void* m_pfnUseFlag;
	void* m_pfnUse;
	void* m_pfnBlockedFlag;
	void* m_pfnBlocked;
	int prologue[26];
#ifdef __linux__
	#ifndef STEAMCMD
		void** vtable;
	#endif
#endif
} cbase_t;

inline void** GetVtable(char* szClass)
{
	void** vtable = NULL;
	edict_t* pEdict = CREATE_ENTITY();

	CALL_GAME_ENTITY(PLID,szClass,&pEdict->v);

	if(pEdict->pvPrivateData)
		vtable = *((void***)(((char*)pEdict->pvPrivateData)+VTABLE_OFFSET));

	if(pEdict)
		REMOVE_ENTITY(pEdict);

	return vtable;
}

inline void* RegisterHam(void** vtable, int vfunc, void* hook)
{
	void* ofunc = vtable[vfunc+VTABLE_START];

	vtable[vfunc+VTABLE_START] = hook;

	return ofunc;
}

inline int C_INDEX(edict_t* e) { return (*g_engfuncs.pfnIndexOfEdict)(e); }
inline int C_INDEX(entvars_t* pev) { return (*g_engfuncs.pfnIndexOfEdict)(pev->pContainingEntity); }
inline int C_INDEX(cbase_t* ent) { return (*g_engfuncs.pfnIndexOfEdict)(ent->pev->pContainingEntity); }

inline edict_t* C_EDICT(int id) { return (*g_engfuncs.pfnPEntityOfEntIndex)(id); }
inline edict_t* C_EDICT(entvars_t* pev) { return pev->pContainingEntity; }
inline edict_t* C_EDICT(cbase_t* ent) { return ent->pev->pContainingEntity; }

inline entvars_t* C_PEV(int id) { return &C_EDICT(id)->v; }
inline entvars_t* C_PEV(edict_t* e) { return &e->v; }
inline entvars_t* C_PEV(cbase_t* ent) { return ent->pev; }

inline cbase_t* C_CBASE(int id) { return (cbase_t*)(C_EDICT(id)->pvPrivateData); }
inline cbase_t* C_CBASE(edict_t* e) { return (cbase_t*)e->pvPrivateData; }
inline cbase_t* C_CBASE(entvars_t* pev) { return (cbase_t*)pev->pContainingEntity->pvPrivateData; }

#endif
