
#ifndef _ZP50_CORE_
#define _ZP50_CORE_

#include "sdk/amxxmodule.h"
#include "gamedll_utils.h"

#define ZP_VERSION_STR_LONG "5.0.5"
#define ZP_VERSION_STRING "5.0.5"
#define ZP_VERSION_NUM 505

#define ZP_MAX_STRING 256

#define PLUGIN_CONTINUE		0	/* Results returned by public functions */
#define PLUGIN_HANDLED		1	/* stop other plugins */
#define PLUGIN_HANDLED_MAIN	2	/* to use in client_command(), continue all plugins but stop the command */

extern cell AMX_NATIVE_CALL zp_core_is_zombie(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_is_first_zombie(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_is_last_zombie(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_is_last_human(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_get_zombie_count(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_get_human_count(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_infect(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_cure(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_force_infect(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_force_cure(AMX *amx, cell *params);
extern cell AMX_NATIVE_CALL zp_core_respawn_as_zombie(AMX *amx, cell *params);

extern void ZP_ServerActivate_Post();
extern void ZP_ClientDisconnect_Post(int id);
extern void ZP_PlayerSpawn_Post(int id);
extern void ZP_PlayerKilled_Post(int id, int attacker, int igib);
extern void ZP_OnPluginsLoaded();
extern void ZP_OnAmxxAttach();

extern void CheckLastZombieHuman();
extern void InfectPlayer(int id, int attacker);
extern void CurePlayer(int id, int attacker);
extern int GetZombieCount();
extern int GetHumanCount();

enum
{
	FW_USER_INFECT_PRE = 0,
	FW_USER_INFECT,
	FW_USER_INFECT_POST,
	FW_USER_CURE_PRE,
	FW_USER_CURE,
	FW_USER_CURE_POST,
	FW_USER_LAST_ZOMBIE,
	FW_USER_LAST_HUMAN,
	FW_USER_SPAWN_POST,
	FW_USER_END
};

#define flag_get(A,B) (A & (1 << (B & 31)))
#define flag_get_boolean(A,B) (flag_get(A,B) ? true : false)
#define flag_set(A,B) A |= (1 << (B & 31))
#define flag_unset(A,B) A &= ~(1 << (B & 31))

#define IS_PLAYER(x)	(0 < x <= gpGlobals->maxClients)
#define IS_PLAYER_ALIVE(x)	(x->v.flags != FL_SPECTATOR && (x->v.team && x->v.playerclass) && x->v.deadflag == DEAD_NO && x->v.health > 0)
#define IS_PLAYER_CONNECTED(x)	(flag_get_boolean(g_IsInGame, x))

extern int g_Forwards[FW_USER_END];

extern int g_IsInGame;
extern int g_ForwardResult;
extern int g_IsZombie;
extern int g_RespawnAsZombie;
extern int g_IsFirstZombie;
extern int g_IsLastZombie;
extern int g_IsLastHuman;

extern cvar_t* zp_version;

#endif
