
#include "sdk/amxxmodule.h"
#include "zp50_core.h"

void** vtbl_CBasePlayer = NULL;

typedef void (*CBasePlayer__Spawn_t)(cbase_t*);
typedef void (*CBasePlayer__Killed_t)(cbase_t*, entvars_t*, int);

CBasePlayer__Spawn_t CBasePlayer__Spawn = NULL;
CBasePlayer__Killed_t CBasePlayer__Killed = NULL;

void ServerActivate_Post(edict_t* pEdictList, int edictCount, int clientMax)
{
	ZP_ServerActivate_Post();
}

void ClientPutInServer_Post(edict_t *pEntity)
{
	g_Players->PutInServer(pEntity);
	SET_META_RESULT(MRES_IGNORED);
}

void ClientDisconnect_Post(edict_t* pEntity)
{
	int id = C_INDEX(pEntity);
	ZP_ClientDisconnect_Post(id);

	g_Players->Disconnect(pEntity);
	SET_META_RESULT(MRES_IGNORED);
}

void PlayerSpawn_Post(cbase_t* self)
{
	if(!IS_USER_CONNECTED(self) && self->pev->flags & FL_FAKECLIENT)
		g_Players->PutInServer(self);

	CBasePlayer__Spawn(self);

	if(IS_USER_CONNECTED(self))
	{
		int id = C_INDEX(self);
		ZP_PlayerSpawn_Post(id);
	}
}

void PlayerKilled_Post(cbase_t* self, entvars_t* pAttacker, int iGib)
{
	CBasePlayer__Killed(self, pAttacker, iGib);

	int id = C_INDEX(self);
	ZP_PlayerKilled_Post(id, C_INDEX(pAttacker), iGib);
}

void OnPluginsLoaded()
{
	ZP_OnPluginsLoaded();
	
	vtbl_CBasePlayer = GetVtable("player");

	// ham player spawnpost
	CBasePlayer__Spawn = (CBasePlayer__Spawn_t)RegisterHam(vtbl_CBasePlayer, 0, (void*)PlayerSpawn_Post);

	// ham player killedpost
	CBasePlayer__Killed = (CBasePlayer__Killed_t)RegisterHam(vtbl_CBasePlayer, 14, (void*)PlayerKilled_Post);

	// ham bot spawnpost
	// ham bot killedpost

	g_Players = new CPlayerHandler(gpGlobals->maxClients);
}

void OnAmxxAttach()
{
	ZP_OnAmxxAttach();
}

